"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var _1 = require("./");
var DatabaseStack = /** @class */ (function () {
    function DatabaseStack(dbs) {
        this.dbs = {};
        this.root = path_1.dirname(require.main.filename || process.mainModule.filename);
        this.init(dbs);
    }
    DatabaseStack.prototype.init = function (dbs) {
        var _this = this;
        Object.keys(dbs).map(function (k) {
            var db = dbs[k];
            _this.dbs[k] = _this.setup(db);
        });
    };
    DatabaseStack.prototype.setup = function (db) {
        return new _1.DataBaseModel(db).dir(path_1.join(this.root, "models", db.dir));
    };
    DatabaseStack.prototype.associate = function () {
        var _this = this;
        Object.keys(this.dbs).map(function (k) {
            _this.dbs[k].associate(_this.dbs[k], _this.dbs);
        });
        return this.dbs;
    };
    DatabaseStack.prototype.expose = function () {
        return this.associate();
    };
    return DatabaseStack;
}());
exports.default = DatabaseStack;
